Index: channels/chan_gtalk.c
===================================================================
--- channels/chan_gtalk.c	(revision 54001)
+++ channels/chan_gtalk.c	(working copy)
@@ -1115,6 +1115,7 @@
 	struct hostent *hp;
 	struct ast_hostent ahp;
 	struct sockaddr_in sin;
+	struct sockaddr_in aux;
 
 	if (time(NULL) == p->laststun)
 		return 0;
@@ -1129,8 +1130,25 @@
 		sin.sin_port = htons(tmp->port);
 		snprintf(username, sizeof(username), "%s%s", tmp->username,
 				 p->ourcandidates->username);
+		
+		ast_rtp_get_peer(p->rtp, &aux);
 
-		ast_rtp_stun_request(p->rtp, &sin, username);
+		if (aux.sin_addr.s_addr && 
+		    aux.sin_addr.s_addr != sin.sin_addr.s_addr) {
+			if (option_debug > 3) {
+				ast_log(LOG_DEBUG, "Receiving RTP traffic from IP %s, differs from remote candidate's IP %s\n", ast_inet_ntoa(aux.sin_addr), tmp->ip);
+				ast_log(LOG_DEBUG, "Sending STUN request to %s\n", ast_inet_ntoa(aux.sin_addr));
+			}
+			ast_rtp_stun_request(p->rtp, &aux, username);
+		}
+		else {
+			if (option_debug > 3) {
+				ast_log(LOG_DEBUG, "Receiving RTP traffic from IP %s, matches with remote candidate's IP %s\n", ast_inet_ntoa(aux.sin_addr), tmp->ip);
+				ast_log(LOG_DEBUG, "Sending STUN request to %s\n", tmp->ip);
+			}
+			ast_rtp_stun_request(p->rtp, &sin, username);
+		}
+
 		tmp = tmp->next;
 	}
 	return 1;
